// Copyright 2023 The Accumulate Authors
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

package errors

// GENERATED BY go run ./tools/cmd/gen-enum. DO NOT EDIT.

import (
	"encoding/json"
	"fmt"
	"strings"
)

// OK is returned when the request completed successfully.
const OK Status = 200

// BadRequest is returned when the request was invalid.
const BadRequest Status = 400

// NoPassword is returned when an encryption password is required.
const NoPassword Status = 401

// BadPassword is returned when an incorrect decryption password.
const BadPassword Status = 403

// NotFound is returned when a record could not be found.
const NotFound Status = 404

// NotSupported is returned when a feature is used in a way that is not supported.
const NotSupported Status = 405

// Conflict is returned when the request failed due to a conflict.
const Conflict Status = 409

// OnePassNotSupported is returned when 1Password integration isn't supported.
const OnePassNotSupported Status = 411

// VaultUnspecified is returned when a request requires a vault but none was specified.
const VaultUnspecified Status = 412

// InternalError is returned when an internal error occurred.
const InternalError Status = 500

// UnknownError is returned when an unknown error occurred.
const UnknownError Status = 501

// EncodingError is returned when encoding or decoding failed.
const EncodingError Status = 502

// UnknownRpcError is returned when an unknown error occurred.
const UnknownRpcError Status = 503

// GetEnumValue returns the value of the Status
func (v Status) GetEnumValue() uint64 { return uint64(v) }

// SetEnumValue sets the value. SetEnumValue returns false if the value is invalid.
func (v *Status) SetEnumValue(id uint64) bool {
	u := Status(id)
	switch u {
	case OK, BadRequest, NoPassword, BadPassword, NotFound, NotSupported, Conflict, OnePassNotSupported, VaultUnspecified, InternalError, UnknownError, EncodingError, UnknownRpcError:
		*v = u
		return true
	}
	return false
}

// String returns the name of the Status.
func (v Status) String() string {
	switch v {
	case OK:
		return "ok"
	case BadRequest:
		return "badRequest"
	case NoPassword:
		return "noPassword"
	case BadPassword:
		return "badPassword"
	case NotFound:
		return "notFound"
	case NotSupported:
		return "notSupported"
	case Conflict:
		return "conflict"
	case OnePassNotSupported:
		return "1passwordNotSupported"
	case VaultUnspecified:
		return "vaultUnspecified"
	case InternalError:
		return "internalError"
	case UnknownError:
		return "unknownError"
	case EncodingError:
		return "encodingError"
	case UnknownRpcError:
		return "unknownRpcError"
	}
	return fmt.Sprintf("Status:%d", v)
}

// StatusByName returns the named Status.
func StatusByName(name string) (Status, bool) {
	switch strings.ToLower(name) {
	case "ok":
		return OK, true
	case "badrequest":
		return BadRequest, true
	case "nopassword":
		return NoPassword, true
	case "badpassword":
		return BadPassword, true
	case "notfound":
		return NotFound, true
	case "notsupported":
		return NotSupported, true
	case "conflict":
		return Conflict, true
	case "onepassnotsupported":
		return OnePassNotSupported, true
	case "1passwordnotsupported":
		return OnePassNotSupported, true
	case "vaultunspecified":
		return VaultUnspecified, true
	case "internalerror":
		return InternalError, true
	case "unknownerror":
		return UnknownError, true
	case "encodingerror":
		return EncodingError, true
	case "unknownrpcerror":
		return UnknownRpcError, true
	}
	return 0, false
}

// MarshalJSON marshals the Status to JSON as a string.
func (v Status) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.String())
}

// UnmarshalJSON unmarshals the Status from JSON as a string.
func (v *Status) UnmarshalJSON(data []byte) error {
	var s string
	err := json.Unmarshal(data, &s)
	if err != nil {
		return err
	}

	var ok bool
	*v, ok = StatusByName(s)
	if !ok || strings.ContainsRune(v.String(), ':') {
		return fmt.Errorf("invalid Status %q", s)
	}
	return nil
}
